{{
Quickstart Crap Games Contest -
"COG OF WAR" - v1 - variation on 'tug of war' for two players, by Tubular
Player one madly taps button P7 to try and lure the "LED marker" to their end
Player two madly taps button P0 to try and lure the "LED marker" to their end
}}
  
CON
  _CLKMODE = XTAL1 + PLL16X
  _CLKFREQ = 80_000_000
  gain = 5                                              'larger value for shorter games
  initposition = 100                                    'initial midway position for start of game

VAR
 long newstate                                          'stores the latest button state
 long oldstate                                          'stores the previous button states
 long position  

OBJ
  Buttons     :      "Touch Buttons 2"                 

PUB Main
  Buttons.start                                                                 'initialise button sensing code                   
  dira[23..16]~~                                                                '8 outputs for LEDs on P16..23          
  position := initposition                                                      'start the LED marker in the middle
  
  repeat   
    'CHECK BUTTON STATE
    newstate := buttons.state
    if ((newstate & 128) == 128) and ((oldstate & 128) == 0)                    'is P7 pressed at left end of quickstart?
      position -= gain                                                          'move position marker towards P7
    if ((newstate & 1) == 1) and ((oldstate & 1) == 0)                          'is P0 pressed at right end of quickstart?
      position += gain                                                          'move position marker towards P0 
    oldstate := newstate                                                        'record button state for comparison next time round
    
    'UPDATE THE LEDs 
    outa[16..23] := %00000000                                                   'reset all 8 leds to off briefly  
    if (position < 35)                                                           
      outa[23] := 1                                                             'led on P23 is at the P7 end (low position value)
    if (position > 15) and (position < 60)                                      'overlap the LED regions for better effect and even start
      outa[22]:=1
    if (position > 40) and (position < 85)
      outa[21]:=1
    if (position > 65) and (position <110)
      outa[20]:=1
    if (position > 90) and (position <135)
      outa[19]:=1
    if (position >115) and (position <160)
      outa[18]:=1
    if (position >140) and (position <185)
      outa[17]:=1
    if (position >165 )
      outa[16] := 1                                                             'led on P16 is at the P0 end (high position value)

    'CHECK FOR A WINNER!!
    if (position> 185)                                  'P0 is the winner!
      repeat 10                                         'toggle 10 times (= 5 flashes)
        !outa[16]                                       'toggle the led at the P0 end
        waitcnt(_CLKFREQ/3+CNT)                         'delay 1/3 of a second between LED state toggles
      position:=initposition                                  'reset the positions and start again

    if (position < 15)                                  'P7 is the winner! 
      repeat 10                                         'toggle 10 times (= 5 flashes)
        !outa[23]                                       'toggle the led at P7 end
        waitcnt(_CLKFREQ/3+CNT)                         'delay 1/3 of a second between LED state toggles
      position:= initposition                                 'reset the positions and start again
        
      
      